{ config, lib, ... }:

let
  domain = "htpro.giugl.io";
  
  utilities = import ./utilities.nix { inherit lib config; };
  inherit (utilities) architectInterfaceAddress;
in
{
  services = {
    prowlarr.enable = true;

    nginx.virtualHosts.${domain} = {
      forceSSL = true;
      enableACME = true;
      locations."/" = {
        proxyPass = "http://127.0.0.1:9696";
        extraConfig = ''
          allow ${config.architect.networks.lan.net};
          allow ${config.architect.networks.tailscale.net};
          deny all;
        '';
      };

      #      locations."/api" = {
      #        proxyPass = "http://127.0.0.1:9696/prowlarr/api";
      #      };
      #
      #      locations."/Content" = {
      #        proxyPass = "http://127.0.0.1:9696/prowlarr/Content";
      #      };
    };
  };
  
  networking.extraHosts = ''
    ${architectInterfaceAddress "lan"} ${domain}
    ${architectInterfaceAddress "wireguard"} ${domain}
    ${architectInterfaceAddress "tailscale"} ${domain}
  '';

  users.groups.media.members = [ "prowlarr" ];
}
